/*
 * This file is copyright Harold Tay (c) 1998 and is released under
 * the GNU General Public License version 2.  See file COPYING or
 * write to Free Software Foundation, Inc, 675 Mass Ave, Cambridge
 * MA, 02139, USA.
 */
/*
 * alternative to getopt.  DOES NOT FOLLOW GETOPT STANDARD.
 * opts is string of flag chars for which an argument is expected.
 * opt_ind is current index to argv.  option flag is returned, unless
 * no options are found, then -1 is returned.  If that option flag
 * is in opts (has an associated value), that value is in opt_arg,
 * or NULL if no value was found.  Caller can set opt_ind to start
 * option checking at any point.
 */

static const char rcsid[] = "$Id: opt.c,v 1.1 1998/08/31 17:22:30 harold Exp $";

int opt_ind = 0;
char * opt_arg = 0;
static int opt_char = 0;

int
opt_get(int c, char ** v, char * opts)
{
  if( 0 == opt_ind )opt_ind = 1;

  while( 1 ){
    if( opt_ind >= c )goto done;
    if( 0 == opt_char ){
      if( '-' != v[opt_ind][opt_char] )goto done;
      opt_char++;
      if( '-' == v[opt_ind][opt_char] )
        if( ! v[opt_ind][opt_char + 1] ){
          opt_arg = 0; opt_char = 0; return(-1); }
      if( ! v[opt_ind][opt_char] )goto noarg; /* bare dash */
    }
    if( ! v[opt_ind][opt_char] ){ opt_ind++; opt_char =  0; continue; }
    break;
  }

  for(; *opts && *opts != v[opt_ind][opt_char]; opts++);
  if( ! *opts )goto noarg;

  if( ! v[opt_ind][opt_char + 1] ){  /* arg not catted with flag */
    if( opt_ind + 1 == c ){ opt_arg = 0; return(*opts); }
    opt_arg = v[opt_ind + 1];
    opt_ind += 2;
  }else{  /* arg catted with flag */
    opt_arg = v[opt_ind] + opt_char + 1;
    opt_ind++;
  }
  opt_char = 0;
  return(*opts);

noarg:
  opt_arg = 0;
  return(v[opt_ind][opt_char++]);
done:
  opt_arg = 0;
  opt_char = 0;
  return(-1);
}

#ifdef UNIT
#include <unistd.h>
#include "out.h"
int
main(int argc, char ** argv)
{
  char buf[128];
  int i;
  i = read(0, buf, sizeof(buf)-1);
  if( i <= 0 )exit(1);
  buf[i-1] = '\0';
  while( -1 != (i = opt_get(argc, argv, buf)) ){
    writef(1, "returned %d, opt_ind:%d, opt_arg:%s\n", i, opt_ind, opt_arg);
  }
  exit(0);
}
#endif
