%{
/*
 * This file (sn-words.l) is part of the sn package.
 * Distribution of sn is covered by the GPL. See file COPYING.
 * sn is copyright (c) 1998 Harold Tay.
 */
/*
 * Scanner to get interesting words from a news spool.
 */

#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include "config.h"
#include "path.h"
#include <out.h>
#include <cmdopen.h>

extern void putword(char *);
extern void putmessageid(char *);
int min_word_length = 3;
int max_word_length = 15;
int pipefd;

#define YY_INPUT(b,r,m) do{ r = read(pipefd, b, m); }while( 0 )

%}

%x BODY EAT

word [a-z0-9]{3,15}
worthless1 article.*<[^@]*@[a-z0-9.]*>.*[:.]
worthless2 message.*<[^@]*@[a-z0-9.]*>.*[:.]
worthless3 post.*<[^@]*@[a-z0-9.]*>.*[:.]
contraction [a-z]+'[ts]
base64 ^[a-z0-9+/]+=?\r\n

%%

<INITIAL>\r\n\r\n        {
                           BEGIN(BODY);
                         }

<INITIAL>^Message-id:.*$ {
                           putmessageid(yytext);
                           BEGIN(EAT);
                         }
<INITIAL>.|\n            ;

<EAT>\r\n\r\n            {
                           BEGIN(BODY);
                         }
<EAT>.|\n                ;
<EAT>^\.[\r\n]*$         {
                           BEGIN(INITIAL);
                         }

<BODY>^\.[\r\n]*$        {
                           BEGIN(INITIAL);
                         }
<BODY>{worthless1}       ;
<BODY>{worthless2}       ;
<BODY>{worthless3}       ;
<BODY>{contraction}      ;
<BODY>{base64} ;
<BODY>the ;
<BODY>and ;
<BODY>for ;
<BODY>you ;
<BODY>that ;
<BODY>wrote ;
<BODY>with ;
<BODY>have ;
<BODY>this ;
<BODY>com ;
<BODY>are ;
<BODY>not ;
<BODY>but ;
<BODY>can ;
<BODY>from ;
<BODY>your ;
<BODY>all ;
<BODY>one ;
<BODY>what ;
<BODY>will ;
<BODY>there ;
<BODY>would ;
<BODY>any ;
<BODY>they ;
<BODY>like ;
<BODY>was ;
<BODY>http ;
<BODY>about ;
<BODY>just ;
<BODY>has ;
<BODY>more ;
<BODY>www ;
<BODY>some ;
<BODY>out ;
<BODY>only ;
<BODY>get ;
<BODY>how ;
<BODY>know ;
<BODY>which ;
<BODY>when ;
<BODY>other ;
<BODY>use ;
<BODY>please ;
<BODY>time ;
<BODY>also ;
<BODY>then ;
<BODY>good ;
<BODY>1997 ;
<BODY>who ;
<BODY>than ;
<BODY>does ;
<BODY>them ;
<BODY>now ;
<BODY>very ;
<BODY>want ;
<BODY>need ;
<BODY>should ;
<BODY>been ;
<BODY>see ;
<BODY>could ;
<BODY>way ;
<BODY>anyone ;
<BODY>their ;
<BODY>where ;
<BODY>thanks ;
<BODY>into ;
<BODY>because ;
<BODY>here ;
<BODY>these ;
<BODY>had ;
<BODY>much ;
<BODY>why ;
<BODY>most ;
<BODY>may ;
<BODY>used ;
<BODY>many ;
<BODY>same ;
<BODY>two ;
<BODY>too ;
<BODY>first ;
<BODY>problem ;
<BODY>still ;
<BODY>our ;
<BODY>really ;
<BODY>over ;
<BODY>must ;
<BODY>something ;
<BODY>those ;
<BODY>were ;
<BODY>say ;
<BODY>such ;
<BODY>take ;
<BODY>his ;
<BODY>before ;
<BODY>call ;
<BODY>after ;
<BODY>looking ;
<BODY>try ;
<BODY>off ;
<BODY>another ;
<BODY>both ;
<BODY>since ;
<BODY>being ;
<BODY>better ;
<BODY>while ;
<BODY>through ;
<BODY>did ;
<BODY>its ;
<BODY>without ;
<BODY>etc ;
<BODY>thing ;
<BODY>got ;
<BODY>writes ;
<BODY>might ;
<BODY>made ;
<BODY>own ;
<BODY>going ;
<BODY>look ;
<BODY>around ;
<BODY>give ;
<BODY>following ;
<BODY>long ;
<BODY>sure ;
<BODY>actually ;
<BODY>day ;
<BODY>send ;
<BODY>few ;
<BODY>either ;
<BODY>things ;
<BODY>down ;
<BODY>put ;
<BODY>however ;
<BODY>above ;
<BODY>come ;
<BODY>anything ;
<BODY>said ;
<BODY>tell ;
<BODY>real ;
<BODY>every ;
<BODY>enough ;
<BODY>always ;
<BODY>again ;
<BODY>yes ;
<BODY>high ;
<BODY>ever ;
<BODY>says ;
<BODY>great ;
<BODY>let ;
<BODY>least ;
<BODY>probably ;
<BODY>him ;
<BODY>though ;
<BODY>yet ;
<BODY>seems ;
<BODY>check ;
<BODY>done ;
<BODY>else ;
<BODY>able ;
<BODY>keep ;
<BODY>possible ;
<BODY>under ;
<BODY>times ;
<BODY>thank ;
<BODY>getting ;
<BODY>doing ;
<BODY>maybe ;
<BODY>comes ;
<BODY>away ;
<BODY>rather ;
<BODY>having ;
<BODY>big ;
<BODY>written ;
<BODY>once ;
<BODY>less ;
<BODY>hand ;
<BODY>job ;
<BODY>next ;
<BODY>word ;
<BODY>change ;
<BODY>quite ;
<BODY>regards ;
<BODY>makes ;
<BODY>open ;
<BODY>seen ;
<BODY>{word}             {
                           putword(yytext);
                         }

<BODY>.|\n               ;


%%

void
putmessageid(char * text)
{
  char * id;
  char * cp;
  cp = text + 11;
  cp += strspn(cp, " \t\r\n");
  if( '<' != *cp )return;
  cp++;
  id = cp;
  cp = strchr(id, '>');
  if( NULL == cp )return;
  *cp = '\0';
  writef(1, "\001%s\n", id);
}

void
putword(char * text)
{
  char * cp;
  if( yyleng >= min_word_length && yyleng <= max_word_length ){
    for(cp = text; *cp; cp++)
      if( isupper(*cp) )*cp = tolower(*cp);
    writef(1, "%s\n", text);
  }
}

int yywrap(void) { return(1); }

int
main(int argc, char ** argv)
{
  int pid;
  char * cp;
  char ** c;
  int i;

  progname = ((cp = strrchr(argv[0], '/'))?cp + 1:argv[0]);

  c = malloc((argc + 2)*sizeof(char *));
  if( NULL == c )FAIL(2, "malloc:%m");
  c[0] = "sncat";
  c[1] = "-n";
  for(i = 1; i < argc; i++)c[i+1] = argv[i];
  c[i+1] = NULL;

  set_path_var();
  pid = cmdopen(c, &pipefd, 0);
  if( pid <= 0 )FAIL(2, "fork/exec:%m");
  yylex();
  close(pipefd);
  i = cmdwait(pid);
  if( i ){
    if( 19 == i )fail(1, "Can't find sncat, set PATH variable");
    fail(2, "sncat failed");
  }
  exit(0);
}
